# (A) INIT
# (A1) LOAD MODULES
from flask import Flask, render_template, request, make_response
from werkzeug.utils import secure_filename
import S2_db as dblib

# (A2) SETTINGS + INIT
HOST_NAME = "localhost"
HOST_PORT = 80
app = Flask(__name__)
# app.debug = True

# (B) UPLOAD ENDPOINTS
# (B1) FILE UPLOAD PAGE
@app.route("/", methods=["GET", "POST"])
def index():
  return render_template("S3_upload.html")

# (B2) SAVE UPLOADED FILE
@app.route("/upload", methods = ["POST"])
def dbsave():
  up = request.files["upload"]
  dblib.save(
    secure_filename(up.filename),
    up.content_type,
    up.read()
  )
  return "OK"

# (C) DOWNLOAD ENDPOINTS
# (C1) FORCE DOWNLOAD
@app.route("/download", methods=["GET"])
def dbload():
  dbfile = request.args.get("f")
  dbfile = None if dbfile is None else dblib.load(dbfile)
  if dbfile is None:
    return make_response("Not Found", 404)
  else:
    response = make_response(dbfile[2])
    response.headers["Content-type"] = dbfile[1]
    response.headers["Content-Transfer-Encoding"] = "Binary"
    response.headers["Content-Disposition"] = "attachment; filename=\"%s\"" % dbfile[0]
    return response

# (C2) SHOW IMAGE FROM DATABASE
@app.route("/show", methods=["GET"])
def dbshow():
  dbfile = request.args.get("f")
  dbfile = None if dbfile is None else dblib.load(dbfile)
  if dbfile is None:
    return make_response("Not Found", 404)
  else:
    response = make_response(dbfile[2])
    response.headers["Content-type"] = dbfile[1]
    return response

# (D) START
if __name__ == "__main__":
  app.run(HOST_NAME, HOST_PORT)